import theater.*;


public class Mutter extends AdvancedActor {
    static final double speed = 5.0;

    public Mutter() {
        setImage("mutter.gif");
        setPriority(Zufall.zufall(Thread.MIN_PRIORITY, Thread.MAX_PRIORITY));
    }

    public void run() {
        boolean first = true;

        while (true) {
            geheZurKueche(first);
            first = false;

            Essen essen = nimmEssen();

            if (essen == null) {
                break;
            }

            geheZumTeller(essen);
            gibEssen(essen);
        }
    }

    private void geheZurKueche(boolean first) {
        Cell cell = new Cell(Zufall.zufall(100, 300), Zufall.zufall(50, 100));

        while (!first && !cell.intersects(this)) {
            int direction = (int) getRotation(cell.getCol(), cell.getRow());
            move(direction, speed);
        }

        while (!(new Cell(Haus.KUECHE_X, Haus.KUECHE_Y).intersects(this))) {
            int direction = (int) getRotation(Haus.KUECHE_X, Haus.KUECHE_Y);
            move(direction, speed);
        }
    }

    private Essen nimmEssen() {
        Haus haus = (Haus) getStage();

        synchronized (haus) {
            if (haus.essenVorhanden()) {
                Essen essen = haus.getEssen();
                essen.nehmen();

                return essen;
            }
        }

        return null;
    }

    private void geheZumTeller(Essen essen) {
        essen.setZCoordinate(1);

        Cell cell = new Cell(Zufall.zufall(100, 300), Zufall.zufall(350, 440));

        while (!cell.intersects(this)) {
            int direction = (int) getRotation(cell.getCol(), cell.getRow());
            move(direction, speed);
            essen.setLocation(this.getColumn(), this.getRow());
        }

        Teller teller = ((Haus) getStage()).getTeller();

        while (!intersects(teller)) {
            int direction = (int) getRotation(teller.getColumn(),
                    teller.getRow());
            move(direction, speed);
            essen.setLocation(this.getColumn(), this.getRow());
        }
    }

    private void gibEssen(Essen essen) {
        Teller teller = ((Haus) getStage()).getTeller();
        teller.essenHinlegen(essen, this);
    }
}
