import theater.*;


public class Teller extends Prop {
    private Essen essen;

    Teller() {
        setImage("teller.gif");
        essen = null;
    }

    synchronized public void essenHinlegen(Essen e, Mutter mutter) { // produce

        while (this.essen != null) {
            try {
                wait();
            } catch (InterruptedException exc) {
            }
        }

        zumTellerGehen(e, mutter);
        this.essen = e;
        notifyAll();
    }

    synchronized public Essen essenWegnehmen(Baby baby, Cell zelle) { // consume

        while (essen == null) {
            try {
                wait();
            } catch (InterruptedException exc) {
            }
        }

        while (!new Cell(this.getColumn(), this.getRow()).intersects(baby)) {
            int direction = (int) baby.getRotation(this.getColumn(),
                    this.getRow());
            baby.move(direction, Baby.speed);
        }

        Essen e = this.essen;
        this.essen = null;
        vomTellerWeggehen(e, baby, zelle);
        notifyAll();

        return e;
    }

    private void zumTellerGehen(Essen e, Mutter mutter) {
        while (!new Cell(this.getColumn(), this.getRow()).intersects(mutter)) {
            int direction = (int) mutter.getRotation(this.getColumn(),
                    this.getRow());
            mutter.move(direction, Mutter.speed);
            e.setLocation(mutter.getColumn(), mutter.getRow());
        }

        e.setLocation(this.getColumn(), this.getRow());
    }

    private void vomTellerWeggehen(Essen e, Baby baby, Cell zelle) {
        e.setZCoordinate(1);

        while (baby.intersects(this)) {
            int direction = (int) baby.getRotation(zelle.getCol(),
                    zelle.getRow());
            baby.move(direction, baby.speed);
            e.setLocation(baby.getColumn(), baby.getRow());
        }
    }
}
